// Contents
//
// Navbar
// Navbar brand
// Navbar nav
// Navbar text
// Navbar divider
// Responsive navbar
// Navbar position
// Navbar themes


// Navbar
//
// Provide a static navbar from which we expand to create full-width, fixed, and
// other navbar variations.

.c-navbar {
   position: relative;
   display: flex;
   flex-wrap: wrap; // allow us to do the line break for collapsing content
   align-items: center;
   justify-content: space-between; // space out brand from logo
   padding: $navbar-padding-y $navbar-padding-x;

   // Because flex properties aren't inherited, we need to redeclare these first
   // few properties so that content nested within behave properly.
   >.o-container,
   >.o-container-fluid {
      display: flex;
      flex-wrap: wrap;
      align-items: center;
      justify-content: space-between;
   }
}


// Navbar brand
//
// Used for brand, project, or site names.

.c-navbar__brand {
  display: inline-block;
  padding-top: $navbar-brand-padding-y;
  padding-bottom: $navbar-brand-padding-y;
  margin-right: $navbar-padding-x;
  @include font-size($navbar-brand-font-size);
  line-height: inherit;
  white-space: nowrap;

  @include hover-focus {
    text-decoration: none;
  }
}


// Navbar nav
//
// Custom navbar navigation (doesn't require `.nav`, but does make use of `.c-nav__link`).

.c-navbar__nav {
  display: flex;
  flex-direction: column; // cannot use `inherit` to get the `.c-navbar`s value
  padding-left: 0;
  margin-bottom: 0;
  list-style: none;

  .c-nav__link {
    padding-right: 0;
    padding-left: 0;
  }

  .c-dropdown-menu {
    position: static;
    float: none;
  }
}


// Navbar text
//
//

.c-navbar__text {
  display: inline-block;
  padding-top: $nav-link-padding-y;
  padding-bottom: $nav-link-padding-y;
}


// Responsive navbar
//
// Custom styles for responsive collapsing and toggling of navbar contents.
// Powered by the collapse Bootstrap JavaScript plugin.

// When collapsed, prevent the toggleable navbar contents from appearing in
// the default flexbox row orientation. Requires the use of `flex-wrap: wrap`
// on the `.c-navbar` parent.
.c-navbar__collapse {
  flex-basis: 100%;
  flex-grow: 1;
  // For always expanded or extra full navbars, ensure content aligns itself
  // properly vertically. Can be easily overridden with flex utilities.
  align-items: center;
}

// Button for toggling the navbar when in its collapsed state
.c-navbar__toggler {
  padding: $navbar-toggler-padding-y $navbar-toggler-padding-x;
  @include font-size($navbar-toggler-font-size);
  line-height: 1;
  background-color: transparent; // remove default button style
  border: $border-width solid transparent; // remove default button style
  @include border-radius($navbar-toggler-border-radius);

  @include hover-focus {
    text-decoration: none;
  }
}

// Keep as a separate element so folks can easily override it with another icon
// or image file as needed.
.c-navbar__toggler-icon {
  display: inline-block;
  width: 1.5em;
  height: 1.5em;
  vertical-align: middle;
  content: "";
  background: no-repeat center center;
  background-size: 100% 100%;
}

// Generate series of `.c-navbar-expand-*` responsive classes for configuring
// where your navbar collapses.
.c-navbar__expand {
  @each $breakpoint in map-keys($grid-breakpoints) {
    $next: breakpoint-next($breakpoint, $grid-breakpoints);
    $infix: breakpoint-infix($next, $grid-breakpoints);

    &#{$infix} {
      @include media-breakpoint-down($breakpoint) {

        >.o-container,
        >.o-container-fluid {
          padding-right: 0;
          padding-left: 0;
        }
      }

      @include media-breakpoint-up($next) {
        flex-flow: row nowrap;
        justify-content: flex-start;

        .c-navbar__nav {
          flex-direction: row;

          .c-dropdown-menu {
            position: absolute;
          }

          .c-nav__link {
            padding-right: $navbar-nav-link-padding-x;
            padding-left: $navbar-nav-link-padding-x;
          }
        }

        // For nesting containers, have to redeclare for alignment purposes
        >.o-container,
        >.o-container-fluid {
          flex-wrap: nowrap;
        }

        .c-navbar__collapse {
          display: flex !important; // stylelint-disable-line declaration-no-important

          // Changes flex-bases to auto because of an IE10 bug
          flex-basis: auto;
        }

        .c-navbar__toggler {
          display: none;
        }
      }
    }
  }
}


// Navbar themes
//
// Styles for switching between navbars with light or dark background.

// Dark links against a light background
.c-navbar--light {
  .c-navbar--brand {
    color: $navbar-light-brand-color;

    @include hover-focus {
      color: $navbar-light-brand-hover-color;
    }
  }

  .c-navbar__nav {
    .c-nav__link {
      color: $navbar-light-color;

      @include hover-focus {
        color: $navbar-light-hover-color;
      }

      &.disabled {
        color: $navbar-light-disabled-color;
      }
    }

    .show>.c-nav__link,
    .active>.c-nav__link,
    .c-nav__link.show,
    .c-nav__link.active {
      color: $navbar-light-active-color;
    }
  }

  .c-navbar__toggler {
    color: $navbar-light-color;
    border-color: $navbar-light-toggler-border-color;
  }

  .c-navbar__toggler-icon {
    background-image: $navbar-light-toggler-icon-bg;
  }

  .c-navbar__text {
    color: $navbar-light-color;

    a {
      color: $navbar-light-active-color;

      @include hover-focus {
        color: $navbar-light-active-color;
      }
    }
  }
}

// White links against a dark background
.c-navbar--dark {
  .c-navbar--brand {
    color: $navbar-dark-brand-color;

    @include hover-focus {
      color: $navbar-dark-brand-hover-color;
    }
  }

  .c-navbar__nav {
    .c-nav__link {
      color: $navbar-dark-color;

      @include hover-focus {
        color: $navbar-dark-hover-color;
      }

      &.disabled {
        color: $navbar-dark-disabled-color;
      }
    }

    .show>.c-nav__link,
    .active>.c-nav__link,
    .c-nav__link.show,
    .c-nav__link.active {
      color: $navbar-dark-active-color;
    }
  }

  .c-navbar__toggler {
    color: $navbar-dark-color;
    border-color: $navbar-dark-toggler-border-color;
  }

  .c-navbar__toggler-icon {
    background-image: $navbar-dark-toggler-icon-bg;
  }

  .c-navbar__text {
    color: $navbar-dark-color;

    a {
      color: $navbar-dark-active-color;

      @include hover-focus {
        color: $navbar-dark-active-color;
      }
    }
  }
}
